package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.AflnetProperties;
import com.example.fuzzControll.constents.CmdConstent;
import com.example.fuzzControll.exception.AflnetException;
import com.example.fuzzControll.exception.CmdException;
import com.example.fuzzControll.pojo.vo.CmdStartParams;
import com.example.fuzzControll.service.TestService;
import com.example.fuzzControll.tools.CmdTools;
import com.example.fuzzControll.tools.GlobalParameters;
import com.example.fuzzControll.tools.TestControlTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Service("testService")
@Slf4j
public class TestServiceImpl implements TestService {

    CmdTools cmdTools = new CmdTools();

    @Autowired
    AflnetProperties aflnetProperties;

    //todo 不同服务不同端口
    @Override
    public void testStart(CmdStartParams cmdStartParams) throws AflnetException, CmdException {
        TestControlTools.setIsRunning(true);
        String cmd = cmdTools.parse(cmdStartParams);
        Date date = new Date();
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd-hh-mm-ss-");
        String outputFileName = df.format(date)+cmdStartParams.getProtopcol()+"-output";
        String finalCmd = CmdConstent.RUN_AFLNET_BEFORE + outputFileName + CmdConstent.RUN_AFLNET_AFTER + cmd + aflnetProperties.getAflnetPath() + "live555/testProgs/testOnDemandRTSPServer 8554";
        log.info("The cmd is [{}]",finalCmd);
        cmdTools.runProgramCmd(finalCmd, outputFileName + ".zip");

    }


    @Override
    public void testStop() {
        TestControlTools.setIsRunning(false);
        log.info("Aflnet has been stopped ! ");
    }
}
